<?php

if ( ! function_exists( 'theaisle_elated_general_options_map' ) ) {
	/**
	 * General options page
	 */
	function theaisle_elated_general_options_map() {
		
		theaisle_elated_add_admin_page(
			array(
				'slug'  => '',
				'title' => esc_html__( 'General', 'theaisle' ),
				'icon'  => 'fa fa-institution'
			)
		);
		
		$panel_design_style = theaisle_elated_add_admin_panel(
			array(
				'page'  => '',
				'name'  => 'panel_design_style',
				'title' => esc_html__( 'Design Style', 'theaisle' )
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'google_fonts',
				'type'          => 'font',
				'default_value' => '-1',
				'label'         => esc_html__( 'Google Font Family', 'theaisle' ),
				'description'   => esc_html__( 'Choose a default Google font for your site', 'theaisle' ),
				'parent'        => $panel_design_style
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'additional_google_fonts',
				'type'          => 'yesno',
				'default_value' => 'no',
				'label'         => esc_html__( 'Additional Google Fonts', 'theaisle' ),
				'parent'        => $panel_design_style
			)
		);
		
		$additional_google_fonts_container = theaisle_elated_add_admin_container(
			array(
				'parent'          => $panel_design_style,
				'name'            => 'additional_google_fonts_container',
				'dependency' => array(
					'show' => array(
						'additional_google_fonts'  => 'yes'
					)
				)
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'additional_google_font1',
				'type'          => 'font',
				'default_value' => '-1',
				'label'         => esc_html__( 'Font Family', 'theaisle' ),
				'description'   => esc_html__( 'Choose additional Google font for your site', 'theaisle' ),
				'parent'        => $additional_google_fonts_container
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'additional_google_font2',
				'type'          => 'font',
				'default_value' => '-1',
				'label'         => esc_html__( 'Font Family', 'theaisle' ),
				'description'   => esc_html__( 'Choose additional Google font for your site', 'theaisle' ),
				'parent'        => $additional_google_fonts_container
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'additional_google_font3',
				'type'          => 'font',
				'default_value' => '-1',
				'label'         => esc_html__( 'Font Family', 'theaisle' ),
				'description'   => esc_html__( 'Choose additional Google font for your site', 'theaisle' ),
				'parent'        => $additional_google_fonts_container
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'additional_google_font4',
				'type'          => 'font',
				'default_value' => '-1',
				'label'         => esc_html__( 'Font Family', 'theaisle' ),
				'description'   => esc_html__( 'Choose additional Google font for your site', 'theaisle' ),
				'parent'        => $additional_google_fonts_container
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'additional_google_font5',
				'type'          => 'font',
				'default_value' => '-1',
				'label'         => esc_html__( 'Font Family', 'theaisle' ),
				'description'   => esc_html__( 'Choose additional Google font for your site', 'theaisle' ),
				'parent'        => $additional_google_fonts_container
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'google_font_weight',
				'type'          => 'checkboxgroup',
				'default_value' => '',
				'label'         => esc_html__( 'Google Fonts Style & Weight', 'theaisle' ),
				'description'   => esc_html__( 'Choose a default Google font weights for your site. Impact on page load time', 'theaisle' ),
				'parent'        => $panel_design_style,
				'options'       => array(
					'100'  => esc_html__( '100 Thin', 'theaisle' ),
					'100i' => esc_html__( '100 Thin Italic', 'theaisle' ),
					'200'  => esc_html__( '200 Extra-Light', 'theaisle' ),
					'200i' => esc_html__( '200 Extra-Light Italic', 'theaisle' ),
					'300'  => esc_html__( '300 Light', 'theaisle' ),
					'300i' => esc_html__( '300 Light Italic', 'theaisle' ),
					'400'  => esc_html__( '400 Regular', 'theaisle' ),
					'400i' => esc_html__( '400 Regular Italic', 'theaisle' ),
					'500'  => esc_html__( '500 Medium', 'theaisle' ),
					'500i' => esc_html__( '500 Medium Italic', 'theaisle' ),
					'600'  => esc_html__( '600 Semi-Bold', 'theaisle' ),
					'600i' => esc_html__( '600 Semi-Bold Italic', 'theaisle' ),
					'700'  => esc_html__( '700 Bold', 'theaisle' ),
					'700i' => esc_html__( '700 Bold Italic', 'theaisle' ),
					'800'  => esc_html__( '800 Extra-Bold', 'theaisle' ),
					'800i' => esc_html__( '800 Extra-Bold Italic', 'theaisle' ),
					'900'  => esc_html__( '900 Ultra-Bold', 'theaisle' ),
					'900i' => esc_html__( '900 Ultra-Bold Italic', 'theaisle' )
				)
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'google_font_subset',
				'type'          => 'checkboxgroup',
				'default_value' => '',
				'label'         => esc_html__( 'Google Fonts Subset', 'theaisle' ),
				'description'   => esc_html__( 'Choose a default Google font subsets for your site', 'theaisle' ),
				'parent'        => $panel_design_style,
				'options'       => array(
					'latin'        => esc_html__( 'Latin', 'theaisle' ),
					'latin-ext'    => esc_html__( 'Latin Extended', 'theaisle' ),
					'cyrillic'     => esc_html__( 'Cyrillic', 'theaisle' ),
					'cyrillic-ext' => esc_html__( 'Cyrillic Extended', 'theaisle' ),
					'greek'        => esc_html__( 'Greek', 'theaisle' ),
					'greek-ext'    => esc_html__( 'Greek Extended', 'theaisle' ),
					'vietnamese'   => esc_html__( 'Vietnamese', 'theaisle' )
				)
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'        => 'first_color',
				'type'        => 'color',
				'label'       => esc_html__( 'First Main Color', 'theaisle' ),
				'description' => esc_html__( 'Choose the most dominant theme color. Default color is #00bbb3', 'theaisle' ),
				'parent'      => $panel_design_style
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'        => 'page_background_color',
				'type'        => 'color',
				'label'       => esc_html__( 'Page Background Color', 'theaisle' ),
				'description' => esc_html__( 'Choose the background color for page content. Default color is #ffffff', 'theaisle' ),
				'parent'      => $panel_design_style
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'        => 'page_background_image',
				'type'        => 'image',
				'label'       => esc_html__( 'Page Background Image', 'theaisle' ),
				'description' => esc_html__( 'Choose the background image for page content', 'theaisle' ),
				'parent'      => $panel_design_style
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'page_background_image_repeat',
				'type'          => 'yesno',
				'default_value' => 'no',
				'label'         => esc_html__( 'Page Background Image Repeat', 'theaisle' ),
				'description'   => esc_html__( 'Enabling this option will set the background image as a repeating pattern throughout the page, otherwise the image will appear as the cover background image', 'theaisle' ),
				'parent'        => $panel_design_style
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'        => 'selection_color',
				'type'        => 'color',
				'label'       => esc_html__( 'Text Selection Color', 'theaisle' ),
				'description' => esc_html__( 'Choose the color users see when selecting text', 'theaisle' ),
				'parent'      => $panel_design_style
			)
		);
		
		/***************** Passepartout Layout - begin **********************/
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'boxed',
				'type'          => 'yesno',
				'default_value' => 'no',
				'label'         => esc_html__( 'Boxed Layout', 'theaisle' ),
				'parent'        => $panel_design_style
			)
		);
		
			$boxed_container = theaisle_elated_add_admin_container(
				array(
					'parent'          => $panel_design_style,
					'name'            => 'boxed_container',
					'dependency' => array(
						'show' => array(
							'boxed'  => 'yes'
						)
					)
				)
			);
		
				theaisle_elated_add_admin_field(
					array(
						'name'        => 'page_background_color_in_box',
						'type'        => 'color',
						'label'       => esc_html__( 'Page Background Color', 'theaisle' ),
						'description' => esc_html__( 'Choose the page background color outside box', 'theaisle' ),
						'parent'      => $boxed_container
					)
				);
				
				theaisle_elated_add_admin_field(
					array(
						'name'        => 'boxed_background_image',
						'type'        => 'image',
						'label'       => esc_html__( 'Background Image', 'theaisle' ),
						'description' => esc_html__( 'Choose an image to be displayed in background', 'theaisle' ),
						'parent'      => $boxed_container
					)
				);
				
				theaisle_elated_add_admin_field(
					array(
						'name'        => 'boxed_pattern_background_image',
						'type'        => 'image',
						'label'       => esc_html__( 'Background Pattern', 'theaisle' ),
						'description' => esc_html__( 'Choose an image to be used as background pattern', 'theaisle' ),
						'parent'      => $boxed_container
					)
				);
				
				theaisle_elated_add_admin_field(
					array(
						'name'          => 'boxed_background_image_attachment',
						'type'          => 'select',
						'default_value' => '',
						'label'         => esc_html__( 'Background Image Attachment', 'theaisle' ),
						'description'   => esc_html__( 'Choose background image attachment', 'theaisle' ),
						'parent'        => $boxed_container,
						'options'       => array(
							''       => esc_html__( 'Default', 'theaisle' ),
							'fixed'  => esc_html__( 'Fixed', 'theaisle' ),
							'scroll' => esc_html__( 'Scroll', 'theaisle' )
						)
					)
				);
		
		/***************** Boxed Layout - end **********************/
		
		/***************** Passepartout Layout - begin **********************/
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'paspartu',
				'type'          => 'yesno',
				'default_value' => 'no',
				'label'         => esc_html__( 'Passepartout', 'theaisle' ),
				'description'   => esc_html__( 'Enabling this option will display passepartout around site content', 'theaisle' ),
				'parent'        => $panel_design_style
			)
		);
		
			$paspartu_container = theaisle_elated_add_admin_container(
				array(
					'parent'          => $panel_design_style,
					'name'            => 'paspartu_container',
					'dependency' => array(
						'show' => array(
							'paspartu'  => 'yes'
						)
					)
				)
			);
		
				theaisle_elated_add_admin_field(
					array(
						'name'        => 'paspartu_color',
						'type'        => 'color',
						'label'       => esc_html__( 'Passepartout Color', 'theaisle' ),
						'description' => esc_html__( 'Choose passepartout color, default value is #ffffff', 'theaisle' ),
						'parent'      => $paspartu_container
					)
				);
				
				theaisle_elated_add_admin_field(
					array(
						'name'        => 'paspartu_width',
						'type'        => 'text',
						'label'       => esc_html__( 'Passepartout Size', 'theaisle' ),
						'description' => esc_html__( 'Enter size amount for passepartout', 'theaisle' ),
						'parent'      => $paspartu_container,
						'args'        => array(
							'col_width' => 2,
							'suffix'    => 'px or %'
						)
					)
				);
		
				theaisle_elated_add_admin_field(
					array(
						'name'        => 'paspartu_responsive_width',
						'type'        => 'text',
						'label'       => esc_html__( 'Responsive Passepartout Size', 'theaisle' ),
						'description' => esc_html__( 'Enter size amount for passepartout for smaller screens (tablets and mobiles view)', 'theaisle' ),
						'parent'      => $paspartu_container,
						'args'        => array(
							'col_width' => 2,
							'suffix'    => 'px or %'
						)
					)
				);
				
				theaisle_elated_add_admin_field(
					array(
						'parent'        => $paspartu_container,
						'type'          => 'yesno',
						'default_value' => 'no',
						'name'          => 'disable_top_paspartu',
						'label'         => esc_html__( 'Disable Top Passepartout', 'theaisle' )
					)
				);
		
				theaisle_elated_add_admin_field(
					array(
						'parent'        => $paspartu_container,
						'type'          => 'yesno',
						'default_value' => 'no',
						'name'          => 'enable_fixed_paspartu',
						'label'         => esc_html__( 'Enable Fixed Passepartout', 'theaisle' ),
						'description' => esc_html__( 'Enabling this option will set fixed passepartout for your screens', 'theaisle' )
					)
				);
		
		/***************** Passepartout Layout - end **********************/
		
		/***************** Content Layout - begin **********************/
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'initial_content_width',
				'type'          => 'select',
				'default_value' => '',
				'label'         => esc_html__( 'Initial Width of Content', 'theaisle' ),
				'description'   => esc_html__( 'Choose the initial width of content which is in grid (Applies to pages set to "Default Template" and rows set to "In Grid")', 'theaisle' ),
				'parent'        => $panel_design_style,
				'options'       => array(
					'eltdf-grid-1100' => esc_html__( '1100px - default', 'theaisle' ),
					'eltdf-grid-1300' => esc_html__( '1300px', 'theaisle' ),
					'eltdf-grid-1200' => esc_html__( '1200px', 'theaisle' ),
					'eltdf-grid-1000' => esc_html__( '1000px', 'theaisle' ),
					'eltdf-grid-800'  => esc_html__( '800px', 'theaisle' )
				)
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'preload_pattern_image',
				'type'          => 'image',
				'label'         => esc_html__( 'Preload Pattern Image', 'theaisle' ),
				'description'   => esc_html__( 'Choose preload pattern image to be displayed until images are loaded', 'theaisle' ),
				'parent'        => $panel_design_style
			)
		);
		
		/***************** Content Layout - end **********************/
		
		$panel_settings = theaisle_elated_add_admin_panel(
			array(
				'page'  => '',
				'name'  => 'panel_settings',
				'title' => esc_html__( 'Settings', 'theaisle' )
			)
		);
		
		/***************** Smooth Scroll Layout - begin **********************/
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'page_smooth_scroll',
				'type'          => 'yesno',
				'default_value' => 'no',
				'label'         => esc_html__( 'Smooth Scroll', 'theaisle' ),
				'description'   => esc_html__( 'Enabling this option will perform a smooth scrolling effect on every page (except on Mac and touch devices)', 'theaisle' ),
				'parent'        => $panel_settings
			)
		);
		
		/***************** Smooth Scroll Layout - end **********************/
		
		/***************** Smooth Page Transitions Layout - begin **********************/
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'smooth_page_transitions',
				'type'          => 'yesno',
				'default_value' => 'no',
				'label'         => esc_html__( 'Smooth Page Transitions', 'theaisle' ),
				'description'   => esc_html__( 'Enabling this option will perform a smooth transition between pages when clicking on links', 'theaisle' ),
				'parent'        => $panel_settings
			)
		);
		
			$page_transitions_container = theaisle_elated_add_admin_container(
				array(
					'parent'          => $panel_settings,
					'name'            => 'page_transitions_container',
					'dependency' => array(
						'show' => array(
							'smooth_page_transitions'  => 'yes'
						)
					)
				)
			);
		
				theaisle_elated_add_admin_field(
					array(
						'name'          => 'page_transition_preloader',
						'type'          => 'yesno',
						'default_value' => 'no',
						'label'         => esc_html__( 'Enable Preloading Animation', 'theaisle' ),
						'description'   => esc_html__( 'Enabling this option will display an animated preloader while the page content is loading', 'theaisle' ),
						'parent'        => $page_transitions_container
					)
				);
				
				$page_transition_preloader_container = theaisle_elated_add_admin_container(
					array(
						'parent'          => $page_transitions_container,
						'name'            => 'page_transition_preloader_container',
						'dependency' => array(
							'show' => array(
								'page_transition_preloader'  => 'yes'
							)
						)
					)
				);
				
					theaisle_elated_add_admin_field(
						array(
							'name'   => 'smooth_pt_bgnd_color',
							'type'   => 'color',
							'label'  => esc_html__( 'Page Loader Background Color', 'theaisle' ),
							'parent' => $page_transition_preloader_container
						)
					);
					
					$group_pt_spinner_animation = theaisle_elated_add_admin_group(
						array(
							'name'        => 'group_pt_spinner_animation',
							'title'       => esc_html__( 'Loader Style', 'theaisle' ),
							'description' => esc_html__( 'Define styles for loader spinner animation', 'theaisle' ),
							'parent'      => $page_transition_preloader_container
						)
					);
					
					$row_pt_spinner_animation = theaisle_elated_add_admin_row(
						array(
							'name'   => 'row_pt_spinner_animation',
							'parent' => $group_pt_spinner_animation
						)
					);
					
					theaisle_elated_add_admin_field(
						array(
							'type'          => 'selectsimple',
							'name'          => 'smooth_pt_spinner_type',
							'default_value' => '',
							'label'         => esc_html__( 'Spinner Type', 'theaisle' ),
							'parent'        => $row_pt_spinner_animation,
							'options'       => array(
								'rotate_circles'        => esc_html__( 'Rotate Circles', 'theaisle' ),
								'pulse'                 => esc_html__( 'Pulse', 'theaisle' ),
								'double_pulse'          => esc_html__( 'Double Pulse', 'theaisle' ),
								'cube'                  => esc_html__( 'Cube', 'theaisle' ),
								'rotating_cubes'        => esc_html__( 'Rotating Cubes', 'theaisle' ),
								'stripes'               => esc_html__( 'Stripes', 'theaisle' ),
								'wave'                  => esc_html__( 'Wave', 'theaisle' ),
								'two_rotating_circles'  => esc_html__( '2 Rotating Circles', 'theaisle' ),
								'five_rotating_circles' => esc_html__( '5 Rotating Circles', 'theaisle' ),
								'atom'                  => esc_html__( 'Atom', 'theaisle' ),
								'clock'                 => esc_html__( 'Clock', 'theaisle' ),
								'mitosis'               => esc_html__( 'Mitosis', 'theaisle' ),
								'lines'                 => esc_html__( 'Lines', 'theaisle' ),
								'fussion'               => esc_html__( 'Fussion', 'theaisle' ),
								'wave_circles'          => esc_html__( 'Wave Circles', 'theaisle' ),
								'pulse_circles'         => esc_html__( 'Pulse Circles', 'theaisle' ),
                                'theaisle_preloader'      => esc_html__( 'TheAisle Preloader', 'theaisle' )
							)
						)
					);
					
					theaisle_elated_add_admin_field(
						array(
							'type'          => 'colorsimple',
							'name'          => 'smooth_pt_spinner_color',
							'default_value' => '',
							'label'         => esc_html__( 'Spinner Color', 'theaisle' ),
							'parent'        => $row_pt_spinner_animation
						)
					);

                    theaisle_elated_add_admin_field(array(
                            'name'          => 'pt_loading_logo',
                            'type'          => 'image',
                            'label'         => esc_html__('Preloader Logo', 'theaisle'),
                            'description'   => esc_html__('Choose preloader logo to be displayed until the page is loaded', 'theaisle'),
                            'parent'        => $row_pt_spinner_animation
                        )
                    );
					
					theaisle_elated_add_admin_field(
						array(
							'name'          => 'page_transition_fadeout',
							'type'          => 'yesno',
							'default_value' => 'no',
							'label'         => esc_html__( 'Enable Fade Out Animation', 'theaisle' ),
							'description'   => esc_html__( 'Enabling this option will turn on fade out animation when leaving page', 'theaisle' ),
							'parent'        => $page_transitions_container
						)
					);
		
		/***************** Smooth Page Transitions Layout - end **********************/
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'show_back_button',
				'type'          => 'yesno',
				'default_value' => 'yes',
				'label'         => esc_html__( 'Show "Back To Top Button"', 'theaisle' ),
				'description'   => esc_html__( 'Enabling this option will display a Back to Top button on every page', 'theaisle' ),
				'parent'        => $panel_settings
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'          => 'responsiveness',
				'type'          => 'yesno',
				'default_value' => 'yes',
				'label'         => esc_html__( 'Responsiveness', 'theaisle' ),
				'description'   => esc_html__( 'Enabling this option will make all pages responsive', 'theaisle' ),
				'parent'        => $panel_settings
			)
		);
		
		$panel_custom_code = theaisle_elated_add_admin_panel(
			array(
				'page'  => '',
				'name'  => 'panel_custom_code',
				'title' => esc_html__( 'Custom Code', 'theaisle' )
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'        => 'custom_js',
				'type'        => 'textarea',
				'label'       => esc_html__( 'Custom JS', 'theaisle' ),
				'description' => esc_html__( 'Enter your custom Javascript here', 'theaisle' ),
				'parent'      => $panel_custom_code
			)
		);
		
		$panel_google_api = theaisle_elated_add_admin_panel(
			array(
				'page'  => '',
				'name'  => 'panel_google_api',
				'title' => esc_html__( 'Google API', 'theaisle' )
			)
		);
		
		theaisle_elated_add_admin_field(
			array(
				'name'        => 'google_maps_api_key',
				'type'        => 'text',
				'label'       => esc_html__( 'Google Maps Api Key', 'theaisle' ),
				'description' => esc_html__( 'Insert your Google Maps API key here. For instructions on how to create a Google Maps API key, please refer to our to our documentation.', 'theaisle' ),
				'parent'      => $panel_google_api
			)
		);
	}
	
	add_action( 'theaisle_elated_action_options_map', 'theaisle_elated_general_options_map', theaisle_elated_set_options_map_position( 'general' ) );
}

if ( ! function_exists( 'theaisle_elated_page_general_style' ) ) {
	/**
	 * Function that prints page general inline styles
	 */
	function theaisle_elated_page_general_style( $style ) {
		$current_style = '';
		$page_id       = theaisle_elated_get_page_id();
		$class_prefix  = theaisle_elated_get_unique_page_class( $page_id );
		
		$boxed_background_style = array();
		
		$boxed_page_background_color = theaisle_elated_get_meta_field_intersect( 'page_background_color_in_box', $page_id );
		if ( ! empty( $boxed_page_background_color ) ) {
			$boxed_background_style['background-color'] = $boxed_page_background_color;
		}
		
		$boxed_page_background_image = theaisle_elated_get_meta_field_intersect( 'boxed_background_image', $page_id );
		if ( ! empty( $boxed_page_background_image ) ) {
			$boxed_background_style['background-image']    = 'url(' . esc_url( $boxed_page_background_image ) . ')';
			$boxed_background_style['background-position'] = 'center 0px';
			$boxed_background_style['background-repeat']   = 'no-repeat';
		}
		
		$boxed_page_background_pattern_image = theaisle_elated_get_meta_field_intersect( 'boxed_pattern_background_image', $page_id );
		if ( ! empty( $boxed_page_background_pattern_image ) ) {
			$boxed_background_style['background-image']    = 'url(' . esc_url( $boxed_page_background_pattern_image ) . ')';
			$boxed_background_style['background-position'] = '0px 0px';
			$boxed_background_style['background-repeat']   = 'repeat';
		}
		
		$boxed_page_background_attachment = theaisle_elated_get_meta_field_intersect( 'boxed_background_image_attachment', $page_id );
		if ( ! empty( $boxed_page_background_attachment ) ) {
			$boxed_background_style['background-attachment'] = $boxed_page_background_attachment;
		}
		
		$boxed_background_selector = $class_prefix . '.eltdf-boxed .eltdf-wrapper';
		
		if ( ! empty( $boxed_background_style ) ) {
			$current_style .= theaisle_elated_dynamic_css( $boxed_background_selector, $boxed_background_style );
		}
		
		$paspartu_style     = array();
		$paspartu_res_style = array();
		$paspartu_res_start = '@media only screen and (max-width: 1024px) {';
		$paspartu_res_end   = '}';
		
		$paspartu_header_selector                = array(
			'.eltdf-paspartu-enabled .eltdf-page-header .eltdf-fixed-wrapper.fixed',
			'.eltdf-paspartu-enabled .eltdf-sticky-header',
			'.eltdf-paspartu-enabled .eltdf-mobile-header.mobile-header-appear .eltdf-mobile-header-inner'
		);
		$paspartu_header_appear_selector         = array(
			'.eltdf-paspartu-enabled.eltdf-fixed-paspartu-enabled .eltdf-page-header .eltdf-fixed-wrapper.fixed',
			'.eltdf-paspartu-enabled.eltdf-fixed-paspartu-enabled .eltdf-sticky-header.header-appear',
			'.eltdf-paspartu-enabled.eltdf-fixed-paspartu-enabled .eltdf-mobile-header.mobile-header-appear .eltdf-mobile-header-inner'
		);
		
		$paspartu_header_style                   = array();
		$paspartu_header_appear_style            = array();
		$paspartu_header_responsive_style        = array();
		$paspartu_header_appear_responsive_style = array();
		
		$paspartu_color = theaisle_elated_get_meta_field_intersect( 'paspartu_color', $page_id );
		if ( ! empty( $paspartu_color ) ) {
			$paspartu_style['background-color'] = $paspartu_color;
		}
		
		$paspartu_width = theaisle_elated_get_meta_field_intersect( 'paspartu_width', $page_id );
		if ( $paspartu_width !== '' ) {
			if ( theaisle_elated_string_ends_with( $paspartu_width, '%' ) || theaisle_elated_string_ends_with( $paspartu_width, 'px' ) ) {
				$paspartu_style['padding'] = $paspartu_width;
				
				$paspartu_clean_width      = theaisle_elated_string_ends_with( $paspartu_width, '%' ) ? theaisle_elated_filter_suffix( $paspartu_width, '%' ) : theaisle_elated_filter_suffix( $paspartu_width, 'px' );
				$paspartu_clean_width_mark = theaisle_elated_string_ends_with( $paspartu_width, '%' ) ? '%' : 'px';
				
				$paspartu_header_style['left']              = $paspartu_width;
				$paspartu_header_style['width']             = 'calc(100% - ' . ( 2 * $paspartu_clean_width ) . $paspartu_clean_width_mark . ')';
				$paspartu_header_appear_style['margin-top'] = $paspartu_width;
			} else {
				$paspartu_style['padding'] = $paspartu_width . 'px';
				
				$paspartu_header_style['left']              = $paspartu_width . 'px';
				$paspartu_header_style['width']             = 'calc(100% - ' . ( 2 * $paspartu_width ) . 'px)';
				$paspartu_header_appear_style['margin-top'] = $paspartu_width . 'px';
			}
		}
		
		$paspartu_selector = $class_prefix . '.eltdf-paspartu-enabled .eltdf-wrapper';
		
		if ( ! empty( $paspartu_style ) ) {
			$current_style .= theaisle_elated_dynamic_css( $paspartu_selector, $paspartu_style );
		}
		
		if ( ! empty( $paspartu_header_style ) ) {
			$current_style .= theaisle_elated_dynamic_css( $paspartu_header_selector, $paspartu_header_style );
			$current_style .= theaisle_elated_dynamic_css( $paspartu_header_appear_selector, $paspartu_header_appear_style );
		}
		
		$paspartu_responsive_width = theaisle_elated_get_meta_field_intersect( 'paspartu_responsive_width', $page_id );
		if ( $paspartu_responsive_width !== '' ) {
			if ( theaisle_elated_string_ends_with( $paspartu_responsive_width, '%' ) || theaisle_elated_string_ends_with( $paspartu_responsive_width, 'px' ) ) {
				$paspartu_res_style['padding'] = $paspartu_responsive_width;
				
				$paspartu_clean_width      = theaisle_elated_string_ends_with( $paspartu_responsive_width, '%' ) ? theaisle_elated_filter_suffix( $paspartu_responsive_width, '%' ) : theaisle_elated_filter_suffix( $paspartu_responsive_width, 'px' );
				$paspartu_clean_width_mark = theaisle_elated_string_ends_with( $paspartu_responsive_width, '%' ) ? '%' : 'px';
				
				$paspartu_header_responsive_style['left']              = $paspartu_responsive_width;
				$paspartu_header_responsive_style['width']             = 'calc(100% - ' . ( 2 * $paspartu_clean_width ) . $paspartu_clean_width_mark . ')';
				$paspartu_header_appear_responsive_style['margin-top'] = $paspartu_responsive_width;
			} else {
				$paspartu_res_style['padding'] = $paspartu_responsive_width . 'px';
				
				$paspartu_header_responsive_style['left']              = $paspartu_responsive_width . 'px';
				$paspartu_header_responsive_style['width']             = 'calc(100% - ' . ( 2 * $paspartu_responsive_width ) . 'px)';
				$paspartu_header_appear_responsive_style['margin-top'] = $paspartu_responsive_width . 'px';
			}
		}
		
		if ( ! empty( $paspartu_res_style ) ) {
			$current_style .= $paspartu_res_start . theaisle_elated_dynamic_css( $paspartu_selector, $paspartu_res_style ) . $paspartu_res_end;
		}
		
		if ( ! empty( $paspartu_header_responsive_style ) ) {
			$current_style .= $paspartu_res_start . theaisle_elated_dynamic_css( $paspartu_header_selector, $paspartu_header_responsive_style ) . $paspartu_res_end;
			$current_style .= $paspartu_res_start . theaisle_elated_dynamic_css( $paspartu_header_appear_selector, $paspartu_header_appear_responsive_style ) . $paspartu_res_end;
		}
		
		$current_style = $current_style . $style;
		
		return $current_style;
	}
	
	add_filter( 'theaisle_elated_filter_add_page_custom_style', 'theaisle_elated_page_general_style' );
}